/**
 *
 */
package de.intevation.gnv.action;

import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import de.intevation.gnv.action.sessionmodel.SessionModel;
import de.intevation.gnv.action.sessionmodel.SessionModelFactory;
import de.intevation.gnv.artifactdatabase.client.ArtifactDatabaseClient;
import de.intevation.gnv.artifactdatabase.client.ArtifactDatabaseClientFactory;
import de.intevation.gnv.artifactdatabase.objects.ArtifactDescription;
import de.intevation.gnv.artifactdatabase.objects.DefaultInputParameter;
import de.intevation.gnv.artifactdatabase.objects.InputParameter;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public class DoOutputAction extends ArtifactDatabaseActionBase {

    /**
     * Constructor
     */
    public DoOutputAction() {
        super();
    }

    
    /**
     * @see de.intevation.gnv.action.ArtifactDatabaseActionBase#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     */
    @Override
    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception {
        String target = request.getParameter("target");
        String mimeType = request.getParameter("mimetype");
        
        // TODO Check if ist is propper;
        
        SessionModel sm = SessionModelFactory.getInstance().getSessionModel(request);
        ArtifactDescription ad = (ArtifactDescription)sm.getCurrentArtifact();
        Collection<String> inputParameter = ad.getInputParameter();
        Collection<InputParameter> ips = null;
        if (inputParameter != null){
            ips = new ArrayList<InputParameter>(inputParameter.size());
            Iterator<String> it = inputParameter.iterator();
            while (it.hasNext()){
                String name = it.next();
                String[] values = request.getParameterValues(name);
                InputParameter ip = new DefaultInputParameter(name, values);
                ips.add(ip);
            }
        }
        
        ArtifactDatabaseClient adc = ArtifactDatabaseClientFactory.getInstance().getArtifactDatabaseClient();
        
        response.setContentType(mimeType);
        OutputStream outputStream = response.getOutputStream();
        adc.doOutput(sm.getSelectedArtifactFactory(), sm.getCurrentArtifact(), outputStream, target, mimeType, ips);
        
        outputStream.flush();
        outputStream.close();
        
        return super.execute(mapping, form, request, response);
    }
    

}
